--*****************************************************************************
--*
--*  sequential mass extractor upgrade test shit
--*
--*****************************************************************************
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local GameMain = import('/lua/ui/game/gamemain.lua')
local Button = import('/lua/maui/button.lua').Button
local Group = import('/lua/maui/group.lua').Group

function CreateMexDisplay(parent)

	MexUpList = {}	-- declare when creating, so things dont break elsewhere

-- the group creates a nice depth arrangement. otherwise the buttons show up under the map and dont get mouse input.
	MexUpContainer = Group (parent, "MexUpContainer")
	MexUpContainer:DisableHitTest()
	LayoutHelpers.AtLeftTopIn(MexUpContainer, parent, 0, 0)

    local MexUpButton = UIUtil.CreateCheckbox(MexUpContainer,
        UIUtil.UIFile('/game/resources/mass_btn_dis.dds'),
        UIUtil.UIFile('/game/resources/mass_btn_over.dds'),
        UIUtil.UIFile('/game/resources/mass_btn_up.dds'),
        UIUtil.UIFile('/game/resources/mass_btn_down.dds'),
        UIUtil.UIFile('/game/resources/mass_btn_dis.dds'),
        UIUtil.UIFile('/game/resources/mass_btn_dis.dds'))

    LayoutHelpers.AtLeftTopIn(MexUpButton, MexUpContainer)

	MexUpButton.OnClick = function(self, modifiers)	-- activate mex management
		GameMain.RemoveBeatFunction(MexUpManagerUpdate)	-- shut down no matter what, unless i figure out how to do it right
		if modifiers.Right then
			self:SetCheck(false)
		else
			GameMain.AddBeatFunction(MexUpManagerUpdate)	-- probly not a good idea. may spawn a zillion of them.
			CreateMexUpList()
			self:SetCheck(true)
		end
	end

	mexnumtext = UIUtil.CreateText(MexUpButton, "wtf?", 14, UIUtil.bodyFont)
	LayoutHelpers.CenteredBelow(mexnumtext, MexUpButton, 0)
	mexnumtext:DisableHitTest()

end


function MexUpManagerUpdate()	-- i forget why this is even here. :P
--	UpdateMexLists()
	UpdateMexUpgrades()
end


function UpdateMexUpgrades()
	local wanktext = ""

	-- first try making sure if everything is there... clean up list.
	for mex in MexUpList do
		collapseArray(MexUpList, function(mex) return mex:IsDead() end)
	end

	local numMexes = table.getsize(MexUpList)
	local isUpgrading = 0
	if numMexes > 0 then
		for mex in MexUpList do
			local bp = MexUpList[mex]:GetBlueprint()
			local tempFocusUnit = MexUpList[mex]:GetFocus() 

			if tempFocusUnit and MexUpList[mex] then
				if tempFocusUnit:GetBlueprint().General.UpgradesFrom == bp.BlueprintId then
					isUpgrading = isUpgrading + 1
					numMexes = numMexes - 1
				end
	--			print ("mex"..mex..": upping true")
			else
	--			print ("mex"..mex..": one mex")
			end
		end
	end

	if isUpgrading > 0 then
		wanktext = (string.format("Upping %d", isUpgrading))
	elseif numMexes > 0 then
		wanktext = "ready!"
		UpgradeRandomMex()
--	elseif numMexes <= 3 then
--		wanktext = (string.format("%d", numMexes))
	end

	mexnumtext:SetText(wanktext)
end


-- check to see that appropriate stuff is selected, then create a list of mexes to be upped 
function CreateMexUpList()
	MexUpList = {}
-- DOESNT FUCKING WORK    local selection = EntityCategoryGetUnitList(categories.ALLUNITS)

	local selection = GetSelectedUnits()
	if selection then
		MexUpList = EntityCategoryFilterDown(categories.MASSEXTRACTION, selection)
	end
	print ("mexlist made")
end

function UpgradeRandomMex()
-- GPG dude thing:  IssueUpgrade({unit}, unit:GetBlueprint().General.UpgradesTo)
	local currentSelection = GetSelectedUnits()
	local mex = MexUpList[1]
	SelectUnits( { mex } )

--	local upgradeBP = mex:GetBlueprint().General.UpgradesTo

--	IssueUpgrade({mex}, upgradeBP)
	IssueBlueprintCommand("UNITCOMMAND_Upgrade", mex:GetBlueprint().General.UpgradesTo, 1, false) 

	SelectUnits( currentSelection )
end


-- *************
--[[
for index, unit in ipairs(units) do
  -- save current selection
  local currentSelection = GetSelectedUnits()

  -- select unit and issue upgrade command
  SelectUnits( { unit } )
  IssueBlueprintCommand("UNITCOMMAND_Upgrade", unit:GetBlueprint().General.UpgradesTo, 1, false)
  -- reset to previous selection
  SelectUnits( currentSelection )

  -- loop until unit is upgraded or dead
  while not unit:IsDead() do
    WaitSeconds(1)
  end
end
--]]

