local sca_utils = '/mods/uimod/sca_utils/'
local pathui = '/mods/uimod/hook'
local pathuiimg='/mods/uimod/textures'
local scoreData = import('/lua/ui/game/scoreaccum.lua').scoreData
local Window = import('/lua/maui/window.lua').Window
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Group = import('/lua/maui/group.lua').Group
local UIUtil = import('/lua/ui/uiutil.lua')
local Tooltip = import('/lua/ui/game/tooltip.lua')
local Dragger = import('/lua/maui/dragger.lua').Dragger
Make_ListBox = import(sca_utils .. 'modcontrols.lua').ListBox
local modcontrols=import(sca_utils .. 'modcontrols.lua')
local trad=import(sca_utils .. 'modcontrols.lua').trad
local graph={height=180, left=15,width=140, bottom=25}
local refresh_time=10
local windows_nbr=1
local Beat={}
win_replay=false
local Prefs = import('/lua/user/prefs.lua')--preferences
local snapTable={}

dialog={   -- CHANGE THE TEXT IN DIALOG_TXT.LUA !!!!!
 {name="total units built", path={"general","built","count"},key=1},
 {name="units still alive", path={"general","currentunits","count"},key=2},
 {name="total energy in", path={"resources","energyin","total"},key=8},
 {name="total mass in", path={"resources","massin","total"},key=11},
 {name="score", path={"general","score",false},key=5},
 {name="total kills", path={"general","kills","count"},key=6},
 {name="total lost", path={"general","lost","count"},key=7},
-- {name="energy all", path={"general","built","energy"},key=3},
 {name="energy rate", path={"resources","energyin","rate",fac_mul=10},key=59},
 {name="total energy out", path={"resources","energyout","total"},key=9},
 {name="total energy wasted", path={"resources","energyover",false},key=10},
-- {name="mass all", path={"general","built","mass"},key=4},
  {name="mass rate", path={"resources","massin","rate",fac_mul=10},key=59},
 {name="total mass out", path={"resources","massout","total"},key=12},
 {name="total mass wasted", path={"resources","massover",false},key=13},
 {name="units air built", path={"units","air","built"},key=14},
 {name="units air kills", path={"units","air","kills"},key=15},
 {name="units air lost", path={"units","air","lost"},key=16},
 {name= "units land built", path={"units","land","built"},key=17},
 {name="units land kills", path={"units","land","kills"},key=18},
 {name="units land lost", path={"units","land","lost"},key=19},
 {name= "units naval built", path={"units","naval","built"},key=20},
 {name="units naval kills", path={"units","naval","kills"},key=21},
 {name="units naval lost", path={"units","naval","lost"},key=22},
 {name= "units xp built", path={"units","experimental","built"},key=23},
 {name="units xp kills", path={"units","experimental","kills"},key=24},
{name= "units xp lost", path={"units","experimental","lost"},key=25},
{ name= "units struct built", path={"units","structures","built"},key=26},
{name= "units struct kills", path={"units","structures","kills"},key=27},
{name= "units struct lost", path={"units","structures","lost"},key=28},
-- {name="units cdr built", path={"units","cdr","built"},key=29},
 {name="units cdr kills", path={"units","cdr","kills"},key=30},
 {name="units cdr lost", path={"units","cdr","lost"},key=31}}
 
time_avaible={{name="1x",val=1},{name="2x",val=2},{name="4x",val=4},{name="8x",val=8},{name="16x",val=16},{name="32x",val=32},{name="64x",val=64}}--,{name="30s",val=30},{name="45s",val=45},{name="1m",val=60}}
 
color_avaible={{name="white"},{name="gray"},{name="blue"},{name="red"},{name="yellow"},{name= "green"},{name= "cyan"},{name= "magenta"}}
 
chatColors2 = { "white", "red", "blue", "green", "cyan", "magenta", "yellow",
                    "ff8000", "ff8080", "ffff80",
                    "800080", "808000", "80ff00", "80ffff",
                    "000080", "008080",     "00ff80" }
chatColors={'ffffffff', 'ffff4242', 'ffefff42','ff4fff42', 'ff42fff8', 'ff424fff', 'ffff42eb',"white", "red", "blue", "green", "cyan", "magenta", "yellow",
                    "ff8000", "ff0080", "ff8080", "ff80ff", "ffff80",
                    "800000", "800080", "8000ff",
                    "808000", "8080ff",
                    "80ff00", "80ff80", "80ffff",
                    "000080",
                    "008000", "008080", "0080ff",
                    "00ff80" }
function create_small_windows(index_player)
	if win_replay then return end
	local mainFrame = GetFrame(0)
	local graph_MaxHeight=45
	local armiesInfo = GetArmiesTable()
	local player={}
	nbr_player=0
	local k=0
	for i, v in armiesInfo.armiesTable do
		k=k+1
		if v.showScore and not v.civilian then
			player[i]={}
			nbr_player = nbr_player + 1
			player[i].name=v.nickname
			player[i].color=v.color
			player[i].index=k
		end
	end
	

	local location = {Top = 200, Left = 200, Bottom = 310, Right = nbr_player*90+15}
	local win = Window(mainFrame, 'Economy', nil, nil, false, false, false, 'console_info_player', location)
	win_replay=win
	win.Depth:Set(6000)
	win:SetMinimumResize(nbr_player*70+15, 110)
	win.Right:Set(win.Left()+nbr_player*90+15)
	win.Bottom:Set(win.Top()+110)
	win:SetAlpha(.65,true)
	win.OnClose = function(self) import('/lua/ui/game/gamemain.lua').RemoveBeatFunction(Beat_fct) win:Destroy() win_replay=false end
	local i=0
	local mass={}
	local energy={}
	local massbg={}
	local energybg={}	
	local mass_label={}
	local energy_label={}
	local player_label={}
	local bg={}
	local data={}
	--LOG("------------  ",nbr_player)
	--for name,val in scoreData.current do
	while i<nbr_player do
		i=i+1
		local tmp=i
		local tmp_i=i		
		bg[i]=Bitmap(win)
		bg[i].Left:Set(function() return win.Left() + (tmp-1)*math.floor((win.Width()-15)/nbr_player)+5 +5 end)
		bg[i].Top:Set(function() return win.Top()+32 end) ---scoreData.current[1].general.score end)
		bg[i].Right:Set(function() return win.Left() + (tmp)*math.floor((win.Width()-15)/nbr_player) +5 end)
		bg[i].Bottom:Set(function() return win.Bottom()-25*math.floor((win.Height()-25)/85)  end)
		bg[i]:SetSolidColor(player[i].color)
		bg[i].Depth:Set(win.Depth()+35)
		bg[i]:SetAlpha(.4)
		LayoutHelpers.ResetHeight(bg[i])
		massbg[i]=Bitmap(win)
		massbg[i].Left:Set(function() return bg[tmp_i].Left()+35*((win.Width()-15)/nbr_player/90)  end)
		massbg[i].Top:Set(function() return bg[tmp_i].Top()+5 end) ---scoreData.current[1].general.score end)
		massbg[i].Right:Set(function() return massbg[tmp_i].Left()+8*((win.Width()-15)/nbr_player/90) end)
		massbg[i].Bottom:Set(function() return bg[tmp_i].Bottom()-5  end)
		massbg[i]:SetSolidColor("gray")
		massbg[i].Depth:Set(win.Depth()+39)
		LayoutHelpers.ResetHeight(massbg[i])
		mass[i]=Bitmap(win)
		mass[i].Left:Set(function() return bg[tmp_i].Left()+35*((win.Width()-15)/nbr_player/90)  end)
		mass[i].Top:Set(function() return bg[tmp_i].Top()+5 end) ---scoreData.current[1].general.score end)
		mass[i].Right:Set(function() return mass[tmp_i].Left()+8*((win.Width()-15)/nbr_player/90) end)
		mass[i].Bottom:Set(function() return bg[tmp_i].Bottom()-5  end)
		mass[i]:SetSolidColor("green")
		mass[i].Depth:Set(win.Depth()+40)	
		energybg[i]=Bitmap(win)
		energybg[i].Left:Set(function() return bg[tmp_i].Left()+47*((win.Width()-15)/nbr_player/90)  end)
		energybg[i].Top:Set(function() return bg[tmp_i].Top()+5 end) ---scoreData.current[1].general.score end)
		energybg[i].Right:Set(function() return energybg[tmp_i].Left()+8*((win.Width()-15)/nbr_player/90)  end)
		energybg[i].Bottom:Set(function() return bg[tmp_i].Bottom()-5  end)
		energybg[i]:SetSolidColor("gray")
		energybg[i].Depth:Set(win.Depth()+39)
		energy[i]=Bitmap(win)
		energy[i].Left:Set(function() return bg[tmp_i].Left()+47*((win.Width()-15)/nbr_player/90)  end)
		energy[i].Top:Set(function() return bg[tmp_i].Top()+5 end) ---scoreData.current[1].general.score end)
		energy[i].Right:Set(function() return energy[tmp_i].Left()+8*((win.Width()-15)/nbr_player/90)  end)
		energy[i].Bottom:Set(function() return bg[tmp_i].Bottom()-5  end)
		energy[i]:SetSolidColor("orange")
		energy[i].Depth:Set(win.Depth()+40)
		mass_label[i]=UIUtil.CreateText(win,1, 12, UIUtil.fixedFont)
		--mass_label[i].Left:Set(function() return win.Left() + (tmp-1)*110 +40  - 10 end) --mass_label[i].Width()
		mass_label[i].Right:Set(function() return math.floor(mass[tmp_i].Left()-3) end)
		mass_label[i].Top:Set(function() return math.floor(bg[tmp_i].Top()+ (bg[tmp_i].Height()-mass_label[i].Height())/2) end)
		mass_label[i]:SetColor("green")
		mass_label[i].Depth:Set(win.Depth()+40)	
		mass_label[i]:SetDropShadow(true)
		energy_label[i]=UIUtil.CreateText(win,1, 12, UIUtil.fixedFont)
		energy_label[i].Left:Set(function() return math.floor(energy[tmp_i].Right()+3) end)
		energy_label[i].Top:Set(function() return math.floor(bg[tmp_i].Top()+ (bg[tmp_i].Height()-energy_label[i].Height())/2) end)
		energy_label[i]:SetColor("orange")
		energy_label[i].Depth:Set(win.Depth()+40)
		energy_label[i]:SetDropShadow(true)
		data[i]={}
		data[i].mass_max=1
		data[i].energy_max=1
		player_label[i]=UIUtil.CreateText(win,string.sub(player[i].name,1,15), 10, UIUtil.fixedFont)
		player_label[i].Left:Set(function() return bg[tmp_i].Left()+5 end)
		player_label[i].Top:Set(function() return bg[tmp_i].Bottom()+2 end)
		player_label[i]:SetColor("white") --player[i].color)
		player_label[i]:SetAlpha(.9)
		player_label[i].Depth:Set(win.Depth()+45)
	end

	local function refresh_info()
		if table.getsize(scoreData.current)>0 then
			local i=0
			for name,val in player do
				i=i+1
				
				local tmp_i=i
						--mass[i].Top:Set(function() return win.Bottom()-20  -40*val.ressources.massin.rate/val.general.mass end)
						--energy[i].Top:Set(function() return win.Bottom()-20  -40*val.ressources.energyin.rate/val.general.energy end)
				--		LOG((return_value(0,i,{"resources","massin","rate",fac_mul=10}).."       ".. return_value(0,i,{"resources","massout","rate",fac_mul=10}))) --val.resources.massin.rate*val.general.mass))
				--local fact=bg[i].Height()/(110-30-27-5)
				local mass_rate_val=return_value(0,i,{"resources","massin","rate",fac_mul=10})-return_value(0,i,{"resources","massout","rate",fac_mul=10})
				local energy_rate_val=return_value(0,i,{"resources","energyin","rate",fac_mul=10})-return_value(0,i,{"resources","energyout","rate",fac_mul=10})
				
				local val_mass=return_value(0,i,{"resources","massin","total"})-return_value(0,i,{"resources","massout","total"})-return_value(0,i,{"resources","massover",false})
				if val_mass>data[i].mass_max then data[i].mass_max=val_mass end
				
				local val_energy=return_value(0,i,{"resources","energyin","total"})-return_value(0,i,{"resources","energyout","total"})-return_value(0,i,{"resources","energyover",false})
				if val_energy>data[i].energy_max then data[i].energy_max=val_energy end

				if mass_rate_val<1 and val_mass<1 then val_mass=0 mass_label[i]:SetColor("red") else mass_label[i]:SetColor("green") end
				if energy_rate_val<1 and val_energy<1 then val_energy=0 energy_label[i]:SetColor("red") else energy_label[i]:SetColor("orange") end

				mass_label[i]:SetText(txtplus(mass_rate_val)) --val.resources.massin.rate*val.general.mass))
				energy_label[i]:SetText(txtplus(energy_rate_val)) --val.resources.energyin.total)) --*val.general.energy))
				--LOG(val_mass.."      "..data[tmp_i].mass_max)
				mass[i].Top:Set(function() return mass[tmp_i].Bottom()-(val_mass/data[tmp_i].mass_max)*massbg[tmp_i].Height()  end)  --graph_MaxHeight
				energy[i].Top:Set(function() return energy[tmp_i].Bottom()-(val_energy/data[tmp_i].energy_max)*massbg[tmp_i].Height()   end)
				
				mass_label[i]:SetNewFont(mass_label[i]._font._family(), math.floor(11*((win.Width()-15)/nbr_player/90)))
				energy_label[i]:SetNewFont(energy_label[i]._font._family(), math.floor(11*((win.Width()-15)/nbr_player/90)))
				player_label[i]:SetNewFont(player_label[i]._font._family(), math.floor(11*math.min((win.Height()-25)/85,((win.Width()-15)/nbr_player/90))))
			end
		end
	end
	local click=0
	function Beat_fct()
			click=click+1
			if click>2 then click=0 refresh_info()  end
		
	end
	
	local function create_beat()
		click=0
		import('/lua/ui/game/gamemain.lua').AddBeatFunction(Beat_fct)
	end
	create_beat()

end


function makeKMG(int)
	--if math.abs(int)<0.01 then return 0 end
	if int>=0 then
		local lg=math.log10(int)
		if lg<=3 then return math.floor(int) end
		if lg<=6 then return (math.floor(int/1000)).."."..(math.floor((int/1000)-math.floor(int/1000))*10).." k" end
		if lg<=9 then return  (math.floor(int/1000000)).."."..(math.floor((int/1000000)-math.floor(int/1000000))*10).." M" end
	--LOG(int.."  o ".. lg)
		return (math.floor(int/1000000000)).."."..(math.floor((int/1000000000)-math.floor(int/1000000000))*10).." G"
	else
		int=math.abs(int)
		local lg=math.log10(int)
		if lg<=3 then return math.floor(int*-1) end
		if lg<=6 then return (math.floor(int/-1000)).."."..(math.floor((int/1000)-math.floor(int/1000))*10).." k" end
		if lg<=9 then return  (math.floor(int/-1000000)).."."..(math.floor((int/1000000)-math.floor(int/1000000))*10).." M" end
	--LOG(int.."  o ".. lg)
		return (math.floor(int/-1000000000)).."."..(math.floor((int/1000000000)-math.floor(int/1000000000))*10).." G"
	
	
	end
end

function return_value(periode,player,path)
	local val=0
	if periode==0 then
		if path[3]==nil or path[3]==false then val=scoreData.current[player][path[1]][path[2]]
		else val=scoreData.current[player][path[1]][path[2]][path[3]] end
	else
		if path[3]==nil or path[3]==false then val=scoreData.historical[periode][player][path[1]][path[2]]
			else val=scoreData.historical[periode][player][path[1]][path[2]][path[3]] end
	end
	if path.fac_mul !=nil and val!=nil then val=val*path.fac_mul end
	if val==nil then val=-5 end
	return val
end

function txtplus(int)
	if int==nil then return "0" end
	if int>=0 then return "+"..makeKMG(int) else return makeKMG(int) end
end


function arrange(int)
	local lg=math.log10(int)
	digit=int/math.pow(10,math.floor(lg))
	--LOG(digit)
	if digit<2.4 then return 2.5*math.pow(10,math.floor(lg))
	elseif digit<4.9 then return 5*math.pow(10,math.floor(lg))
	elseif digit<7.5 then return 7.5*math.pow(10,math.floor(lg))
	else return math.pow(10,math.floor(lg)+1)
	end
end

--generic function to put a an 'ok' button to close the panel on a panel
function Make_Button_generic(parent,text,doExit,xOffset,yOffset)
	-- close the Config Panel
	
	--defaults for a quit button on a sca panel
	local x = xOffset or 36
	local y = yOffset or 26
	local name = text or "Ok"
	local quit = true
	if doExit != nil then
		quit = doExit
	end
	
	local okButton = UIUtil.CreateButton(parent, pathuiimg..'/bouton_vide.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds', pathuiimg..'/bouton_vide_actif.dds' , nil, nil, nil, nil, '')
	okButton.Left:Set(function() return parent.Left() + x end)
	okButton.Top:Set(function() return parent.Top() + y end)
	okButton.Depth:Set(parent.Depth()+60)
	local nameText = UIUtil.CreateText(okButton, name , 14, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(nameText, okButton, 3)
	nameText:SetColor("White")
	
	--edit this function to add more functionality to the quit button 
	okButton.OnQuit = function()
	end
	
	--hides the window and calls the OnQuit function
	okButton.OnClick = function()		
		okButton.OnQuit()
		if quit == true then
			Effect.FadeOut(parent,time_effect) --parent:Hide()
		end
	end

	return okButton
end

function CreateConfigWindow(parent)
	local IntegerSlider = import('/lua/maui/slider.lua').IntegerSlider
    local win = Window(GetFrame(0), 'Configure Chat', nil, nil, nil, true, nil, 'chat_config')
    win.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    Tooltip.AddButtonTooltip(win._closeBtn, 'chat_close')
    win.Top:Set(function() return GetFrame(0).Bottom() - 700 end)
    win.Left:Set(function() return GetFrame(0).Left() + 200 end)
    win.Right:Set(function() return win.Left() + 400 end)   
	
            slider_label = UIUtil.CreateText(win, "Transparency", 14, "Arial")
            LayoutHelpers.AtLeftTopIn(slider_label, win,15,50)
            slider = IntegerSlider(win, false, 
                1, 100,5, UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'), 
                UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'), UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), 
                UIUtil.SkinnableFile('/dialogs/options-02/slider-back_bmp.dds'))
            LayoutHelpers.Below(slider, slider_label)
            slider.key = 75
            --slider.Height:Set(function() return 10 end)
            slider.OnValueSet = function(self, newValue)
             end
	
    
    win.OnClose = function(self)
        win:Destroy()
        win = false
    end
end

function create_info_dialog(parent)
local zoom_fact=1
local graph_nbr=0
local graph_enable=0
local graph_data={}
graph_data.highest_value=0
local nbr_player=0
--combo_graph = false
--combo_player = false
--combo_color = false
local busy=false
local click=0
local expand_factor=2

local minimize_factor=1
local win=false
local bminimize=false
local bg_title=false
local tips="Score"
local win_nbr=windows_nbr
Beat[win_nbr]=false
local min_max_val=false 

--if true then return end
	--if win!=nil and win then return end
	windows_nbr=windows_nbr+1
	local mainFrame = GetFrame(0)
	local location = {Top = 200+40*win_nbr, Left = 200+40*win_nbr, Bottom = 200+graph.height+140+win_nbr*40, Right = 200+210+expand_factor*graph.width+40*win_nbr}
	local pt={}
	
	local win = Window(mainFrame, trad('Stat_title').." "..win_nbr, nil, nil, false, true, false, 'console_stat_'..win_nbr, location) -- the 3me true
	win.Depth:Set(win_nbr*4000)
	LayoutHelpers.ResetWidth(win) LayoutHelpers.ResetHeight(win)
	expand_factor=2
	minimize_factor=1
	win:SetMinimumResize(graph.width*expand_factor+210, graph.height+140)

	
	  win.OnPinCheck = function(self, checked)
        win.pinned = checked
        win:SetNeedsFrameUpdate(not checked)
        win.curTime = 0
        --GUI.chatEdit.edit:AcquireFocus()
        if checked then
            Tooltip.AddCheckboxTooltip(win._pinBtn, 'chat_pinned')
        else
            Tooltip.AddCheckboxTooltip(win._pinBtn, 'chat_pin')
        end
    end
    win.OnConfigClick = function(self, checked)
       -- if GUI.config then GUI.config:Destroy() GUI.config = false return end
        CreateConfigWindow(win)
        win:SetNeedsFrameUpdate(false)
        
    end
	Tooltip.AddButtonTooltip(win._closeBtn, 'chat_close')
	
	
	
	--[[local check_label = UIUtil.CreateText(win, "Working when hidden", 14, "Arial")
       check = UIUtil.CreateCheckboxStd(win, '/dialogs/check-box_btn/radio')
       LayoutHelpers.AtLeftTopIn(check, win,60,75)
       LayoutHelpers.RightOf(check_label, check,5)
	check.Depth:Set(win.Depth()+40)
	check_label.Depth:Set(win.Depth()+40)
       LayoutHelpers.AtVerticalCenterIn(check_label, check)

       check.OnCheck = function(self, checked)
		working_hidden=checked
       end
	check:SetCheck(false)]]
	
	
	local max_label=UIUtil.CreateText(win,(graph.height-graph.bottom), 12, UIUtil.titleFont)
	max_label.Left:Set(function() return win.Left() + graph.left+2 end)
	max_label.Top:Set(function() return win.Bottom() - graph.height-graph.bottom -18 end)
	max_label:SetColor("white")
	max_label.Depth:Set(win.Depth()+50)
	local bg=Bitmap(win)
	bg.Left:Set(function() return win.Left() + graph.left end)
	bg.Top:Set(function() return win.Bottom()-graph.bottom -graph.height -2 end) ---scoreData.current[1].general.score end)
	bg.Right:Set(function() return win.Left()+graph.width*expand_factor +2 end)
	bg.Bottom:Set(function() return win.Bottom()-graph.bottom +1  end)
	bg:SetSolidColor("gray")
	bg.Depth:Set(win.Depth()+4)
	
	local grp2=Group(win)
	grp2.Left:Set(0)	grp2.Top:Set(0)	grp2.Right:Set(0)	grp2.Bottom:Set(0)
	
	local j=1
	local quad={}
	while j<6 do
		local tmp=j
		quad[j]=Bitmap(win)
		quad[j].Left:Set(function() return win.Left() + graph.left +1 end)
		quad[j].Top:Set(function() return win.Bottom()-graph.bottom - (graph.height)*((tmp-1)/4) -1 end) ---scoreData.current[1].general.score end)
		quad[j].Right:Set(function() return win.Left()+graph.width*expand_factor +2 end)

		quad[j].Bottom:Set(function() return quad[tmp].Top() +1  end)
		quad[j]:SetSolidColor("white")
		quad[j].Depth:Set(win.Depth()+5)
		j=j+1
	end
	local j=1
	local quadv={}
	while j<8 do
		local tmp=j
		quadv[j]=Bitmap(win)
		quadv[j].Left:Set(function() return win.Left()+graph.left + ((graph.width*expand_factor-graph.left))*((tmp-1)/6)+1  end)
		quadv[j].Top:Set(function() return win.Bottom()-graph.bottom -graph.height -1  end) ---scoreData.current[1].general.score end)
		quadv[j].Right:Set(function() return quadv[tmp].Left() +1 end)

		quadv[j].Bottom:Set(function() return win.Bottom()-graph.bottom  end)
		quadv[j]:SetSolidColor("white")
		quadv[j].Depth:Set(win.Depth()+5)
		j=j+1
	end
	local quadl=Bitmap(win)
	quadl.Left:Set(function() return 5  end)
	quadl.Top:Set(function() return win.Bottom()-graph.bottom -graph.height -1  end) ---scoreData.current[1].general.score end)
	quadl.Right:Set(function() return quadl.Left() +3 end)
	quadl.Bottom:Set(function() return win.Bottom()-graph.bottom  end)
	quadl:SetSolidColor("gray")
	--quadl:Hide()
	
	local graph_list={}
	local Combo = import('/lua/ui/controls/combo.lua').Combo
	local BitmapCombo = import('/lua/ui/controls/combo.lua').BitmapCombo

	local combo_graph=Combo(win, 14, 10, nil, nil, "UI_Tab_Click_01", "UI_Tab_Rollover_01")
	combo_graph.Left:Set(function() return win.Left()+15 end) --function() return 300 end)
	combo_graph.Top:Set(function() return win.Top()+40 end) --function() return 300 end)
	combo_graph.Width:Set(150)
	combo_graph.Depth:Set(win.Depth()+60)
	combo_graph.keyMap={}
	combo_graph.Key=1
	local i=0
	for k,v in dialog do
		i=i+1
		graph_list[i]=trad(v.name)
		combo_graph.keyMap[i]=v.key
	end
	combo_graph:AddItems(graph_list,2)	
	if table.getsize(graph_list) == 1 then
                combo_graph:Disable()
      else
            combo_graph:Enable()
       end
	combo_graph.OnClick = function(self, index, text) 
             self.Key = index
		self.text=text
	end
	combo_graph.Key=2
	combo_graph.text=graph_list[2]
	
	local combo_player=Combo(win, 14, 10, nil, nil, "UI_Tab_Click_01", "UI_Tab_Rollover_01")
	combo_player.Left:Set(function() return win.Left()+175 end) --function() return 300 end)
	combo_player.Top:Set(function() return win.Top()+40 end) --function() return 300 end)
	combo_player.Width:Set(150)
	combo_player.Depth:Set(win.Depth()+61)
	combo_player.keyMap={}
	combo_player.Key=1
	local armiesInfo = GetArmiesTable()
	i=1
	local m=0
	local player_list={}
	for k, v in armiesInfo.armiesTable do
		m=m+1
		if v.showScore and not v.civilian then
			player_list[i]=v.nickname
			combo_player.keyMap[i]=m
			i=i+1
		end
	end
	if import('/lua/ui/game/gamemain.lua').GetReplayState() or GetFocusArmy() == -1 then combo_player:AddItems(player_list,1) else combo_player:AddItems(player_list,GetFocusArmy()) end
	if (table.getsize(player_list) > 1) and (import('/lua/ui/game/gamemain.lua').GetReplayState() or GetFocusArmy() == -1) then
               combo_player:Enable()
      else
            combo_player:Disable()
       end	
	combo_player.OnClick = function(self, index, text) 
             self.Key = index
		self.text=text			
	end
	combo_player.Key=1
	combo_player.text=player_list[1]
	
	local time_list={}
	local combo_time=Combo(win, 14, 10, nil, nil, "UI_Tab_Click_01", "UI_Tab_Rollover_01")
	combo_time.Left:Set(function() return win.Left()+400 end) --function() return 300 end)
	combo_time.Top:Set(function() return win.Top()+40 end) --function() return 300 end)
	combo_time.Width:Set(65)
	combo_time.Depth:Set(win.Depth()+61)
	combo_time.keyMap={}
	combo_time.Key=1
	local i=0
	for k,v in time_avaible do
		i=i+1
		time_list[i]=v.name
		combo_time.keyMap[i]=v.val
	end
	combo_time:AddItems(time_list,1)	
        combo_time.OnClick = function(self, index, text) 
             self.Key = index
		zoom_fact=time_avaible[index].val
		reset_display()
		LOG("-- zoom factor set to ",time_avaible[index].val)
        end
	
	
	local color_list={}
       local combo_color = BitmapCombo(win, chatColors, 3, true, nil, "UI_Tab_Rollover_01", "UI_Tab_Click_01")
	combo_color.Width:Set(55)
	combo_color.key = 1 --data.key
	combo_color.Left:Set(function() return win.Left()+335 end) 
	combo_color.Top:Set(function() return win.Top()+40 end)
	combo_color.Depth:Set(win.Depth()+65)
	combo_color.Key=3
	combo_color.text= chatColors[3]
	combo_color.OnClick = function(self, index) 
             self.Key = index	
		LOG(chatColors[index])
	end
	
	local function refresh_info()
		local data_nbr=table.getsize(scoreData.historical)
		if data_nbr<=0 then return end
		local p=0
		while busy do
			p=p+1
			if p>50000 then return LOG("busy") end
		end
		busy=true
		local stp=false
		local i=0
		for index_graph,data in pt do
			i=graph.left-7
			local index_mem=1
			stp=false
			if (data_nbr/zoom_fact)>(graph.width-8) then index_mem=math.floor(data_nbr/zoom_fact)-graph.width+8 end
			while (i<graph.width) and not stp and (pt[index_graph]!={})do
				i=i+1
				if index_mem>data_nbr then index_mem=0 end
				local val=return_value(index_mem,data.index,data.path)
				if graph_data.highest_value<val then graph_data.highest_value=val end
				if val>graph_data.max then 
					graph_data.max=arrange(val)
				--	if (graph_data.max/graph_data.factor)>(graph.height*.95) then 
						graph_data.factor=graph_data.max/graph.height
						max_label:SetText(math.floor(graph_data.max))
				--	end
				end
				data.bg[i].Top:Set(function() return win.Bottom()-graph.bottom -(val/graph_data.factor*minimize_factor)-3 end)
				if index_mem==0 then stp=true end
				index_mem=index_mem+1*zoom_fact
			end
		end
		if stp then
			local tmp=i+1
			quadl.Left:Set(function() return win.Left() +tmp*expand_factor end)
			quadl.Depth:Set(win.Depth()+50+graph_enable+1)
			quadl:SetAlpha(1)
			--quadl:Show()
		else
			quadl:Hide()
		end
		if min_max_val then 
			min_max_val:SetText(math.floor(graph_data.highest_value).." ")
		end
		busy=false
	end
	
	local function remove_graph(index,nocheck)
	if (graph_enable<=1 and not nocheck) or (graph_enable<=0) then modcontrols.PlayErrorSound() return end
		local p=0
		while busy do
			p=p+1
			if p>50000 then return end
		end
		busy=true

		graph_enable=graph_enable-1
		pt[index].title_label:Destroy()
		pt[index].close_bt:Destroy()
		local i=graph.left-7
		while i<graph.width do
			i=i+1
			pt[index].bg[i]:Destroy()
		end
		local k=0
		local index_remove=0
		--display_graph()
		--LOG("remove pos:",pt[index].title_position)
		--table.remove(pt,pt[index].title_position-1)

		pt[index]=nil
		k=0
		for index_graph,data in pt do
			k=k+1
			local p=k
			pt[index_graph].title_label.Top:Set(function() return win.Bottom() - graph.bottom -(18*p) end)
			pt[index_graph].title_position=k
		end
		--display_graph()	
		

		--LOG(repr(pt))
		graph_data.max=0
		graph_data.highest_value=0
		graph_data.factor=1
		max_label:SetText(0)
		--LOG("remove "..index)
		busy=false
	end
	
	local function display_graph()
		local k=0
		LOG("--------  graph_nbr:",graph_nbr, '      graph_enable:',graph_enable)
		for index_graph,data in pt do
			k=k+1

			LOG('index:',index_graph,'   position:',pt[index_graph].title_position,'   graph_enable:',graph_enable,'    ',pt[index_graph].title)
		end
	end
	local function add_graph(name,color,index,path)
		if graph_enable>=10 then modcontrols.PlayErrorSound() return end
		local i=graph.left-7
		graph_nbr=graph_nbr+1
		graph_enable=graph_enable+1
		local p=0
		while busy do
			p=p+1
			if p>50000 then return end
		end
		busy=true
		local index_graph="graph"..graph_nbr
		pt[index_graph]={}
		pt[index_graph].bg={}
		pt[index_graph].title=name
		pt[index_graph].color=color
		pt[index_graph].index=index
		pt[index_graph].data_path=index
		pt[index_graph].path=path
		pt[index_graph].title_position=graph_enable
		pt[index_graph].title_label=UIUtil.CreateText(win,string.sub(name,1,26), 12, UIUtil.titleFont)
		pt[index_graph].title_label.Left:Set(function() return win.Left() + graph.width*expand_factor + 30 end)
		pt[index_graph].title_label.Top:Set(function() return win.Bottom() - graph.bottom -(18*pt[index_graph].title_position) end)
		pt[index_graph].title_label:SetColor(color)
		pt[index_graph].title_label.Depth:Set(win.Depth()+20)
		--pt[index_graph].title_label:SetNeedsFrameUpdate(true)
		
		pt[index_graph].close_bt = UIUtil.CreateButton(win, pathuiimg..'/graph_close_up.dds', pathuiimg..'/graph_close_down.dds', pathuiimg..'/graph_close_down.dds', pathuiimg..'/graph_close_down.dds' , nil, nil, nil, nil, '')
		pt[index_graph].close_bt.Left:Set(function() return win.Left() + graph.width*expand_factor + 15 end)
		pt[index_graph].close_bt.Top:Set(function() return pt[index_graph].title_label.Top()+1 end)
		pt[index_graph].close_bt.Depth:Set(win.Depth()+21)
		pt[index_graph].close_bt.OnClick = function(self) 
			remove_graph(index_graph)
		end
		
		graph_data.max=0
		graph_data.factor=1		
		while i<graph.width do
			i=i+1
			pt[index_graph].bg[i]=Bitmap(grp2)
			local tmp=i
			local tmp_index=index_graph
			pt[index_graph].bg[i].Left:Set(function() return win.Left() +tmp*expand_factor end)
			pt[index_graph].bg[i].Top:Set(function() return win.Bottom()-graph.bottom -3 end) 
			pt[index_graph].bg[i].Right:Set(function() return pt[tmp_index].bg[tmp].Left()+expand_factor end)
			if i<=graph.left-6 then
				pt[index_graph].bg[i].Bottom:Set(function() return pt[tmp_index].bg[tmp].Top() +expand_factor end)
			else
				pt[index_graph].bg[i].Bottom:Set(function() return pt[tmp_index].bg[tmp-1].Top() +expand_factor  end)
			end
			pt[index_graph].bg[i]:SetSolidColor(pt[index_graph].color)
			pt[index_graph].bg[i].Depth:Set(win.Depth()+5+graph_enable)
			pt[index_graph].bg[i]:DisableHitTest()
		end
		--LOG("x1:",pt.player1.bg[200].Left(),"  y1:",pt.player1.bg[200].Top(),"  x2:",pt.player1.bg[200].Right(),"  y2:",pt.player1.bg[200].Bottom())
		--LOG("x1:",pt.player1.bg[300].Left(),"  y1:",pt.player1.bg[300].Top(),"  x2:",pt.player1.bg[300].Right(),"  y2:",pt.player1.bg[300].Bottom())
		busy=false
		refresh_info()
		--LOG("created")
		return graph_nbr
	end

	local function reset_display()
		local p=0
		while busy do
			p=p+1
			if p>50000 then LOG("not dispo") return end
		end
		busy=true
		for index_graph,data in pt do
			local i=graph.left-7
			while i<graph.width do
				i=i+1
				pt[index_graph].bg[i].Top:Set(function() return win.Bottom()-graph.bottom -3 end)
			end
		end
		graph_data.max=0
		graph_data.factor=1
		busy=false
		refresh_info()
	end
	
	local function Beat_fct()
			click=click+1
			if click>(refresh_time*10) then click=0 refresh_info()  end
		
	end
	
	local function create_beat()
		click=0
		Beat[win_nbr]=Beat_fct
		import('/lua/ui/game/gamemain.lua').AddBeatFunction(Beat[win_nbr])
	end
	
		local minimalist_btn = Make_Button_generic(win,trad("Minimize"),false,70,70)
	minimalist_btn.OnQuit = function()
		win:Hide()
		--win:DisableHitTest()
		minimize_factor=.3
		grp2:Show()
		local bg_line=Bitmap(grp2)
		bminimize=true
		bg_line.Left:Set(function() return win.Left() + graph.left end)
		bg_line.Top:Set(function() return win.Bottom()-graph.bottom -1  end) ---scoreData.current[1].general.score end)
		bg_line.Right:Set(function() return win.Left()+graph.width*expand_factor +2 end)
		bg_line.Bottom:Set(function() return win.Bottom()-graph.bottom +1  end)
		bg_line:SetSolidColor("gray")
		bg_line.Depth:Set(win.Depth()+8)
		bg_line:SetAlpha(1)
		
		local bg_title=Bitmap(grp2)
		bg_title.Left:Set(function() return win.Left() + graph.left end)
		bg_title.Top:Set(function() return win.Bottom()-graph.bottom -graph.height*minimize_factor -1  end) ---scoreData.current[1].general.score end)
		bg_title.Right:Set(function() return win.Left()+graph.width*expand_factor +2 end)
		bg_title.Bottom:Set(function() return win.Bottom()-graph.bottom +1  end)
		bg_title:SetSolidColor("gray")
		bg_title.Depth:Set(win.Depth()+8)
		bg_title:SetAlpha(.1)
		
		local min_title=Bitmap(grp2)
		min_title.Left:Set(function() return win.Left() + graph.left end)
		min_title.Top:Set(function() return min_title.Bottom()-12  end)
		min_title.Right:Set(function() return win.Left()+graph.width*expand_factor +2 end)
		min_title.Bottom:Set(function() return bg_title.Top()  end)
		min_title:SetSolidColor("0a3793")
		min_title.Depth:Set(win.Depth()+8)
		min_title:SetAlpha(.5)
		min_title:Hide()
		
		local min_txt=UIUtil.CreateText(min_title," Stat ".. win_nbr..":   "..tips, 11, UIUtil.titleFont)
		min_txt.Top:Set(min_title.Top)
		min_txt.Left:Set(min_title.Left)
		min_txt:SetColor("white")
	
		min_max_val=UIUtil.CreateText(min_title,math.floor(graph_data.highest_value).." ", 11, UIUtil.titleFont)
		min_max_val.Top:Set(min_title.Top)
		min_max_val.Right:Set(min_title.Right)
		min_max_val:SetColor("white")	
		
		snapTable["mini"..win_nbr]={Left = bg_title.Left(), Top = bg_title.Top(), Right = bg_title.Right(), Bottom = bg_title.Bottom()}
		
		quadl:Hide()
		refresh_info() 
		local onMove=false
		bg_title.HandleEvent = function(self, event)
			if event.Type == 'ButtonPress' then
				--create the table of current marker positions
				local drag = Dragger()
				--dist from mousepointer to left/top
				local off_left = event.MouseX - self.Left()
				local off_top = event.MouseY - self.Top()
				--minimized graph size
				local width = self.Right() - self.Left()
				local height = self.Bottom() - self.Top()
				--full window size
				local winWidth = win.Right() - win.Left()
				local winHeight = win.Bottom() - win.Top()
				--offset from the graph to the window left/top
				local winLeftOff = win.Left() - self.Left()
				local winTopOff = win.Bottom() - self.Top() - winHeight
				--distance to snap, and table of things to snap to
				local snapDist = 15
				snapTable.mainborder = {Left = GetFrame(0).Left(), Top = GetFrame(0).Top(), Right = GetFrame(0).Right(), Bottom = GetFrame(0).Bottom()}
				snapTable["mini"..win_nbr]=nil
				
				drag.OnMove = function(dragself, x, y)
					--win.Bottom:Set(win.Top() - offY)
					local newLeft = x-off_left
					local newTop = y-off_top
					if Prefs.GetFromCurrentProfile("uimanager_sav")["snapCheckBox"]==1 then
						for i, snapPos in snapTable do
							--left/right snapping
							--if control is within snap height of another control then it can be snapped to the left or right
							if (((newTop) < (snapPos.Bottom + snapDist) and (newTop) > (snapPos.Top - snapDist))
							or ((newTop + height) < (snapPos.Bottom + snapDist) and (newTop + height) > (snapPos.Top - snapDist))
							or ((snapPos.Bottom) > (newTop - snapDist) and (snapPos.Bottom) < (newTop + height + snapDist))
							or ((snapPos.Top) > (newTop - snapDist) and (snapPos.Top) < (newTop + height + snapDist))) then
								--snap left side if possible
								if math.abs(newLeft - snapPos.Left) < snapDist then
									newLeft = snapPos.Left
								elseif math.abs(newLeft - snapPos.Right) < snapDist then
									newLeft = snapPos.Right
								end
								--snap right side if possible
								if math.abs(newLeft + width - snapPos.Left) < snapDist then
									newLeft = snapPos.Left - width
								elseif math.abs(newLeft + width - snapPos.Right) < snapDist then
									newLeft = snapPos.Right - width
								end
							end
							--top/bottom snapping, works the same way
							if (((newLeft) < (snapPos.Right + snapDist) and (newLeft) > (snapPos.Left - snapDist))
							or ((newLeft + width) < (snapPos.Right + snapDist) and (newLeft + width) > (snapPos.Left - snapDist))
							or ((snapPos.Right) > (newLeft - snapDist) and (snapPos.Right) < (newLeft + width + snapDist))
							or ((snapPos.Left) > (newLeft - snapDist) and (snapPos.Left) < (newLeft + width + snapDist))) then
								if math.abs(newTop - snapPos.Top) < snapDist then
									newTop = snapPos.Top
								elseif math.abs(newTop - snapPos.Bottom) < snapDist then
									newTop = snapPos.Bottom
								end
								if math.abs(newTop + height - snapPos.Top) < snapDist then
									newTop = snapPos.Top - height
								elseif math.abs(newTop + height - snapPos.Bottom) < snapDist then
									newTop = snapPos.Bottom - height
								end
							end
						end
					end
					--keep the minigraph inside the screen borders
					newLeft = math.min(math.max(GetFrame(0).Left(), newLeft), GetFrame(0).Right() - width)
					newTop = math.min(math.max(GetFrame(0).Top(), newTop), GetFrame(0).Bottom() - height)
					win.Left:Set(newLeft + winLeftOff)
					win.Top:Set(newTop + winTopOff)
					win.Right:Set(newLeft + winLeftOff + winWidth)
					win.Bottom:Set(newTop + winTopOff + winHeight)
					GetCursor():SetTexture(UIUtil.GetCursor('MOVE_WINDOW'))
					onMove=true
				end
				drag.OnRelease = function(dragself)
					GetCursor():Reset()
					drag:Destroy()
					snapTable["mini"..win_nbr]={Left = bg_title.Left(), Top = bg_title.Top(), Right = bg_title.Right(), Bottom = bg_title.Bottom()}
					onMove=false
				end
				PostDragger(self:GetRootFrame(), event.KeyCode, drag)
			elseif (event.Type == 'MouseExit') and not(onMove) then
				bg_title:SetAlpha(.1)
				min_title:Hide()
			elseif (event.Type == 'MouseEnter') and not(onMove) then
				bg_title:SetAlpha(.4)
				min_max_val:SetText(graph_data.highest_value.." ")
				min_title:Show()
			elseif (event.Type == 'ButtonDClick') and not(onMove) then
				snapTable["mini"..win_nbr]=nil
				local height=win.Bottom() - win.Top()
				if win.Top()<0 then 
					win.Top:Set(0)
					win.Bottom:Set(win.Top()+height)
				end
				if win.Right()>GetFrame(0).Right() then 
					local width=win.Right() - win.Left()
					win.Right:Set(GetFrame(0).Right())
					win.Left:Set(win.Right()-width)
				end
				bg_title:Destroy()
				bg_line:Destroy()
				min_title:Destroy()
				min_max_val=false
				win:Show()
				--win:EnableHitTest()
				minimize_factor=1
				quadl:Show()
				bminimize=false
				refresh_info()
			end
		end
	end	
	
	local addButton = Make_Button_generic(win,trad("Add_graph"),false,310,70)
	addButton.OnQuit = function()
		--combo_color:SetValue(chatColors[combo_color.Key+1])
		--LOG(combo_graph.text, '  ',chatColors[combo_color.Key],'  ',combo_player.Key)
		--LOG(dialog[combo_graph.Key].path[1],'  ',dialog[combo_graph.Key].path[2],'  ',dialog[combo_graph.Key].path[3])
		add_graph(combo_player.text..": "..combo_graph.text,  chatColors[combo_color.Key],combo_player.Key,dialog[combo_graph.Key].path)
		tips=""
	end	
	if import('/lua/ui/game/gamemain.lua').GetReplayState() or GetFocusArmy() == -1 then
		local add_all_player_btn = Make_Button_generic(win,trad("Add_all_player"),false,200,70)
		add_all_player_btn.OnQuit = function()
			for index_graph,data in pt do
				remove_graph(index_graph,true)
			end
			local armiesInfo = GetArmiesTable()
			local i=1
			tips=combo_graph.text
			local player_list={}
			for k, v in armiesInfo.armiesTable do
				if v.showScore and not v.civilian then
				add_graph(v.nickname..": "..combo_graph.text,v.color,i,dialog[combo_graph.Key].path)
			--	add_graph(combo_player.text..": "..combo_graph.text,  v.color,combo_player.Key,dialog[combo_graph.Key].path)
			--add_graph(v.nickname..": score ",v.color,i,{"general","score",false})
					i=i+1
				end
			end
		end
	end
	win.OnClose = function(self)
		local p=0
		while busy do
			p=p+1
			if p>500000 then return end
		end
		busy=true
		for index_graph,data in pt do
			remove_graph(index_graph)
		end
		graph_nbr=0
		graph_enable=0
		import('/lua/ui/game/gamemain.lua').RemoveBeatFunction(Beat[win_nbr])
		win:Destroy()
		win=false
		busy=false
	end
	
	local armiesInfo = GetArmiesTable()
	local i=1
	local player_list={}
	for k, v in armiesInfo.armiesTable do
		if v.showScore and not v.civilian then
			add_graph(v.nickname..": score ",v.color,i,{"general","score",false})
			i=i+1
		end
	end
	win:SetAlpha(.75,true)

	--add_graph("score me","white",1,"general","score")
	--add_graph("score AI","red",2,"general","score")
	--add_graph("total ernegy me","orange",1,"resources","energyin","total")
	--add_graph("total mass me","green",1,"resources","massin","total")
	create_beat()
	if import('/lua/ui/game/gamemain.lua').GetReplayState() or GetFocusArmy() == -1 then 
		create_small_windows()
		minimalist_btn.OnQuit()
	end
	
	return win
	
end
	